"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createFirebaseFunctions = exports.FirebaseFunctionDescriptor = void 0;
const FirebaseFunction_1 = require("./FirebaseFunction");
var FirebaseFunctionDescriptor;
(function (FirebaseFunctionDescriptor) {
    function create(firebaseFunctions) {
        return () => firebaseFunctions;
    }
    FirebaseFunctionDescriptor.create = create;
})(FirebaseFunctionDescriptor = exports.FirebaseFunctionDescriptor || (exports.FirebaseFunctionDescriptor = {}));
function createFirebaseFunctions(getPrivateKeys, firebaseFunctions, debugFirebaseFunctions = {}) {
    return {
        debug: createFirebaseFunctionsType(debugFirebaseFunctions, getPrivateKeys),
        ...createFirebaseFunctionsType(firebaseFunctions, getPrivateKeys)
    };
}
exports.createFirebaseFunctions = createFirebaseFunctions;
function createFirebaseFunctionsType(firebaseFunctions, getPrivateKeys) {
    if (typeof firebaseFunctions === 'function')
        return FirebaseFunction_1.FirebaseFunction.create(firebaseFunctions(), getPrivateKeys);
    const firebaseRunnableFunctions = {};
    for (const entry of Object.entries(firebaseFunctions))
        firebaseRunnableFunctions[entry[0]] = createFirebaseFunctionsType(entry[1], getPrivateKeys);
    return firebaseRunnableFunctions;
}
