export interface FunctionType<Parameters, ReturnType, FlattenParameters = undefined> {
    parameters: Parameters;
    return: ReturnType;
    flattenParameters: FlattenParameters;
}
export declare namespace FunctionType {
    type Parameters<T extends FunctionType<unknown, unknown, unknown>> = T extends FunctionType<infer Parameters, unknown, unknown> ? Parameters : never;
    type ReturnType<T extends FunctionType<unknown, unknown, unknown>> = T extends FunctionType<unknown, infer ReturnType, unknown> ? ReturnType : never;
    type FlattenParameters<T extends FunctionType<unknown, unknown, unknown>> = T extends FunctionType<unknown, unknown, infer FlattenParameters> ? (FlattenParameters extends undefined ? Parameters<T> : FlattenParameters) : never;
}
