"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CombineIterator = void 0;
class CombineIterator {
    iterator1;
    iterator2;
    combineElement;
    constructor(iterator1, iterator2, combineElement) {
        this.iterator1 = iterator1;
        this.iterator2 = iterator2;
        this.combineElement = combineElement;
    }
    next() {
        const element1 = this.iterator1.next();
        const element2 = this.iterator2.next();
        if ((element1.done ?? false) || (element2.done ?? false))
            return { done: true, value: undefined };
        return {
            value: this.combineElement(element1.value, element2.value)
        };
    }
}
exports.CombineIterator = CombineIterator;
